#ifndef __LIBTL_DRAW_H
#define __LIBTL_DRAW_H

#ifndef FL_FORMS_H
#endif

#define RGB(r,g,b) ((r*256+g)*256+b)

typedef enum { 
	DRAW_GIF = 0, DRAW_BMP, DRAW_PPM, DRAW_PS 
} TDrawOutputFormat;

typedef struct {
	Picture *pic;
	int      offsetX, offsetY;
	int      textHeight, textWidth;
} DrawBitmap, *PDrawBitmap;

void draw_setup_format (TDrawOutputFormat theFormat);
void draw_setup_size   (int theWidth, int theHeight);
void draw_setup_copyright( const char* theCopyright );

PDrawBitmap draw_init (FL_OBJECT *ob, int *width, int *height, const char* pathname, const char *filename);
void draw_free       (PDrawBitmap db);
void draw_text       (PDrawBitmap db, int x, int y, int c, const char *s);
void draw_text_size  (PDrawBitmap db, int x, int y, int c, int size, const char *s) ;
void draw_pixel      (PDrawBitmap db, int x, int y, int c);
void draw_line       (PDrawBitmap db, int x, int y, int x1, int y1, int c);
void draw_rect       (PDrawBitmap db, int x, int y, int x1, int y1, int c);
void draw_quad       (PDrawBitmap db, int x, int y, int r, int c);
void draw_quad_fill  (PDrawBitmap db, int x, int y, int r, int c);
void draw_circle     (PDrawBitmap db, int x, int y, int r, int c);
void draw_circle_fill(PDrawBitmap db, int x, int y, int r, int c);
void draw_save       (PDrawBitmap db);

#endif /* __LIBTL_DRAW_H */
