
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "libtl_picture.h"
#include "libtl_string.h"

tstring druckBefehl = NULL;
tstring druckName   = NULL;
tstring druckTempPath = NULL;
char druckTitel[80];
int  druckZeile;


void SetupPrinter( const char* theCommand, const char* theTempPath )
{
	SetString(&druckBefehl,theCommand,0);
	SetString(&druckTempPath,theTempPath,0);
}


FILE *OpenPrinter()
{
	time_t t;
	FILE *fLst;
	
	druckZeile    = 0;
	druckTitel[0] = '\0';
	t = time(NULL);
	
	{	char aName[32];
		sprintf(aName,"/libtl%05ld.tmp",t%100000);
		SetStrings( &druckName, druckTempPath, aName );
	}
	
	fLst = fopen(druckName,"w");
	return fLst;  
}

void Print (FILE *fLst, char *t)
{
	if (druckZeile>58) {
		fprintf(fLst,"%c",(char)12);
		if (druckTitel[0]!=0) {
			fprintf(fLst,"   %s\n",druckTitel);
			druckZeile = 1;
		} else 
			druckZeile = 0;
	}
	fprintf(fLst,"    %s\n",t);
	druckZeile++;
}

void ClosePrinter (FILE *fLst)
{
	char befehl[256];
	if (druckZeile>1) 
		fputc(12,fLst);
	fclose(fLst);
	sprintf(befehl,"%s %s",druckBefehl,druckName);
	system(befehl);
}

void PrintScreen (FILE *fLst, Pixel *bmp, int maxX, int maxY, int einschubX, int einschubY)
/* Druck der Grafik von links oben (0,0) bis rechts unten (maxX,maxY).
   Falls maxX=0, dann Druck des ganzen Bildschirms.
*/
{
	int x,y,x1,width;
	unsigned char cb,c;

	width = maxX;
	if (maxX/8!=0) maxX = (maxX/8)*8;
	if (maxY/8!=0) maxY = (maxY/8)*8;
	einschubX /= 8;
	/* HP DeskJet 500 */
	/* 100 Punkte/Zoll */
	fputc(27,fLst);
	fputc(42,fLst);
	fputc(116,fLst);
	fputc(49,fLst);
	fputc(48,fLst);
	fputc(48,fLst);
	fputc(82,fLst);
	fputc(27,fLst);
	fputc(42,fLst);
	fputc(114,fLst);
	fprintf(fLst,"%i",maxX+einschubX*8);
	fputc(83,fLst);
	/* Voreinstellungen */
	fputc(27,fLst);
	fputc(42,fLst);
	fputc(98,fLst);
	fputc('1',fLst);
	fputc(88,fLst);
	fputc(27,fLst);
	fputc(42,fLst);
	fputc(98,fLst);
	fputc('1',fLst);
	fputc(89,fLst);
  for (y=0; y<einschubY; y++) {
    fputc(27,fLst);
    fputc(42,fLst);
    fputc(114,fLst);
    fputc(48,fLst);
    fputc(65,fLst);
    /* Anzahl der zu bertragenen Bytes */
    fputc(27,fLst);
    fputc(42,fLst);
    fputc(98,fLst);
    fprintf(fLst,"1");
    fputc(87,fLst);
    for (x=0; x<einschubX+maxX/8; x++)
	    fputc(0,fLst);
	}
  for (y=0; y<maxY; y++) {
    fputc(27,fLst);
    fputc(42,fLst);
    fputc(114,fLst);
    fputc(48,fLst);
    fputc(65,fLst);
    /* Anzahl der zu bertragenen Bytes */
    fputc(27,fLst);
    fputc(42,fLst);
    fputc(98,fLst);
    fprintf(fLst,"%i",maxX/8+einschubX);
    fputc(87,fLst);
		for (x=0; x<einschubX; x++)
			fputc(0,fLst);
    for (x=0; x<maxX/8; x++) {
      cb=128;
      c=0;
      for (x1=0; x1<8; x1++) {
        if (bmp[x*8+x1+y*width]!=0) c += cb;
        cb /= 2;
      }
      fputc(c,fLst);
    }
  }
	/* Grafik-Ende */
	fputc(27,fLst);
	fputc(42,fLst);
	fputc(114,fLst);
	fputc(66,fLst);
}


