// CGI-Programm zur Datenbank der BAV Artikel
// TL
// 18.&19.02.04: 1. Version

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>

#include "cgi-util.h"

#define MAX_ENTRIES 10000

char pfadStart[512];
char pfadHome[512];
char pfadDaten[512];
char pfadAblage[512];
char pfadRC[512];

char refAuthor[512], refTitle[512], refObject[512], refAbstract[512];
int  refAbstractDisplay;

int   cgiN = 0;
entry cgiEntries[MAX_ENTRIES];

const char* FindEntry( const char* theName )
{
	int x;
	for (x=0; x<cgiN; x++)
	{
		if (strcmp(cgiEntries[x].name,theName)==0)
			return cgiEntries[x].val;
	}
	return NULL;
}


void AppendHTML2File( FILE* fHTML, FILE* fInput )
{
        char zeileStr[256];
        while (fgets(zeileStr,sizeof(zeileStr),fInput)!=NULL)
        {
                //replaceStrByStr(zeileStr,"%FILE%",diskLoad->name);
                //replaceStrByStr(zeileStr,"%NAME%",stern.name);
                fprintf(fHTML,zeileStr);
                fputc('\n',fHTML);
        }
}

void AppendHTML( FILE* fHTML, const char* theAppendName, const char* theAlternativeText )
{
        char filename[512];
        FILE* fTXT = NULL;
	if (theAppendName!=NULL)
	{
	        sprintf(filename,"%s/%s",pfadAblage,theAppendName);
        	fTXT  = fopen(filename,"r");
	}
        if (fTXT==NULL)
        {
                fprintf( fHTML, "%s", theAlternativeText );
        }
        else
        {
                AppendHTML2File( fHTML, fTXT );
                fclose(fTXT);
        }
}


int Error( const char* theText )
{
	FILE* fHTML = stdout;
	AppendHTML( fHTML, "ref_head.html", "<HTML>\n<HEAD>\n<TITLE>Star information</TITLE>\n</HEAD>\n<BODY>\n" );
	fprintf(fHTML,"<H2>Fehler</H2>\n");
	fprintf(fHTML,"<P>\n");
	fprintf(fHTML,theText);
	fprintf(fHTML,"\n");
	AppendHTML( fHTML, "ref_tail.html", "</BODY>\n</HTML>\n" );
	return 1;
}


int Start (char *pfadRC)
{
        char *home;
	char str[256];
	FILE* f;

        home = getenv("HOME");
        if (home==NULL) 
        {
                strcpy(pfadHome,".");
        }
        else 
        {
                strcpy(pfadHome,home);
        }
        sprintf(pfadRC,"%s/.reference.rc",pfadHome);
//fprintf(stdout,"Reading RC: %s<BR>\n",pfadRC);
	
	f = fopen(pfadRC,"r");
	if (f==NULL)
	{
		Error("RC not found");
		return 0;
	}

	strcpy(pfadDaten,pfadStart);
	strcpy(pfadAblage,pfadStart);

	while (fgets(str,sizeof(str),f))
	{
		if (str[strlen(str)-1]==10)
			str[strlen(str)-1] = 0;
		if (strncmp(str,"DATA",4)==0)
		{
			home = str+4;
			while (isspace(*home) && *home!=0)
				home++;
			strcpy(pfadDaten,home);
		}
		if (strncmp(str,"OUT",3)==0)
		{
			home = str+3;
			while (isspace(*home) && *home!=0)
				home++;
			strcpy(pfadAblage,home);
		}
	}
	fclose(f);

	return 1;
}


void TestDataFile( const char* theFileName )
{
	FILE* f;
	char name[512], str[512];
	char setBibcode[512], setAuthor[512], setTitle[512], setURL[512], setObject[512], setAbstract[10000];

	sprintf(name,"%s/%s",pfadDaten,theFileName);
	f = fopen(name,"r");
//fprintf(stdout,"Reading file: %s: %i<BR>\n",name,(int)f);
	if (f)
	{
		int newSet = 1, inAbstract;
		while (fgets(str,sizeof(str),f))
		{
			if (str[strlen(str)-1]==10)
				str[strlen(str)-1] = 0;
			if (newSet)
			{
				setBibcode[0] = 0;
				setAuthor[0] = 0;
				setTitle[0] = 0;
				setURL[0] = 0;
				setObject[0] = 0;
				setAbstract[0] = 0;
				newSet = 0;
				inAbstract = 0;
			}
			if (strlen(str)<3)
			{
				int found = 0;
				if (refAuthor[0] && strstr(setAuthor,refAuthor))
					found = 1;
				if (refTitle[0] && strstr(setTitle,refTitle))
					found = 1;
				if (refObject[0] && strstr(setObject,refObject))
					found = 1;
				if (refAbstract[0] && strstr(setAbstract,refAbstract))
					found = 1;
				if (found)
				{
					FILE *fHTML = stdout;
					fprintf(fHTML,"<LI>\n");
					fprintf(fHTML,"Bibcode: %s<BR>\n",setBibcode);
					fprintf(fHTML,"Titel  : %s<BR>\n",setTitle);
					fprintf(fHTML,"Autor  : %s<BR>\n",setAuthor);
					if (setURL[0])
					fprintf(fHTML,"URL    : <A HREF=\"%s\">%s</A><BR>\n",setURL,setURL);
					if (refAbstractDisplay && setAbstract[0])
					fprintf(fHTML,"Abstract: <I>%s</I><BR>\n",setAbstract);
				}
				newSet = 1;
			}
			else
			if (str[0]=='%')
			switch (str[1])
			{
				case 'R':
					strcpy( setBibcode, str+3 );
					break;
				case 'T':
					strcpy( setTitle, str+3 );
					break;
				case 'A':
					if (setAuthor[0]==0)
						strcpy( setAuthor, str+3 );
					else
					{
						strcat( setAuthor, "; " );
						strcat( setAuthor, str+3 );
					}
					break;
				case 'U':
					strcpy( setURL, str+3 );
					break;
				case 'O':
					if (setObject[0]==0)
						strcpy( setObject, str+3 );
					else
					{
						strcat( setObject, ", " );
						strcat( setObject, str+3 );
					}
					break;
				case 'B':
					strcpy( setAbstract, str+3 );
					inAbstract = 1;
					break;
			}
			else
			if (inAbstract)
				strcat( setAbstract, str );
		}
		fclose(f);
	}
}


void TestDatabase()
{
	struct dirent **dirptr;
	int n;
	char name[512];
	FILE *fHTML = stdout;

	sprintf(name,"%s",pfadDaten);
	n = scandir(name,&dirptr,0,alphasort);
//fprintf(stdout,"scandir %s: %i<BR>\n",name,n);
	AppendHTML( fHTML, "ref_head.html", "<HTML>\n<HEAD>\n<TITLE>Star information</TITLE>\n</HEAD>\n<BODY>\n" );
	fprintf(fHTML,"<UL>\n");
	while (n>0)
	{
		n--;
		strcpy(name,dirptr[n]->d_name);
		if (strcmp(name+strlen(name)-4,".ref")==0)
		{
			TestDataFile(name);
		}
	}
	fprintf(fHTML,"</UL>\n");
	AppendHTML( fHTML, "ref_tail.html", "</BODY>\n</HTML>\n" );
}


int main(int argc, char *argv[])
{
	int ok=0;
	const char* envptr;

	printf("Content-type: text/html\n\n");

	envptr = getenv("REQUEST_METHOD");
	if (envptr==NULL || strcmp(envptr,"POST"))
		return Error("This script should be referenced with a METHOD of POST.\n");
	envptr = getenv("CONTENT_LENGTH");
	{	int x,cl;
		cl = (envptr ? atoi(envptr) : 0);
		for (x=0; cl && (!feof(stdin)); x++)
		{
			cgiN = x+1;
			cgiEntries[x].val = fmakeword(stdin,'&',&cl);
			plustospace(cgiEntries[x].val);
			unescape_url(cgiEntries[x].val);
			cgiEntries[x].name = makeword(cgiEntries[x].val,'=');
		}
	}

#	if 0
	printf("<H1>Query Results</H1>");
	printf("You submitted the following name/value pairs:<p>%c",10);
	printf("<ul>%c",10);

	{	int x;
		for (x=0; x < cgiN; x++)
			printf("<li> <code>%s = %s</code>\n",cgiEntries[x].name,cgiEntries[x].val);
	}
	printf("</ul>\n");
#	endif

	strcpy(pfadStart,argv[0]);
	{	int i = strlen(pfadStart)-1;
		while ((i>=0) && (pfadStart[i]!='/')) i--;
		pfadStart[i+1] = '\0';
	}

	// meine Parameter aus den cgiEntries holen
	envptr = FindEntry("author");
	if (envptr)
	{	ok=1; strcpy(refAuthor,envptr); }
	envptr = FindEntry("title");
	if (envptr)
	{	ok=1; strcpy(refTitle,envptr); }
	envptr = FindEntry("object");
	if (envptr)
	{	ok=1; strcpy(refObject,envptr); }
	envptr = FindEntry("abstract");
	if (envptr)
	{	ok=1; strcpy(refAbstract,envptr); }
	envptr = FindEntry("abstract-display");
	if (envptr)
	{	refAbstractDisplay = strcmp(envptr,"abstract-display")==0; }

	if (!ok)
		return Error("No parameters given to ref_html!");

	if (!Start(pfadRC))
		return Error("Error during startup of ref_html!");

	TestDatabase();

	return 0;
}

