#ifndef __VS_EXTREM_H
#define __VS_EXTREM_H

#include "vs_sub.h"

// Fileformat STE: 
// 	typ date mag obscode comment

typedef struct RExtrem
{
  int		typ;	/* 0:Min, 1:Max */
  double 	datum;
  int 	 	hell;
  char 	 	bemerkung[StrLenBemerkung];
  char		observer[StrLenObsCode];
  struct RExtrem* next;
} RExtrem;

struct RExtrem*	extremFirst;
char activeSTEFilename[StrLenPfad];


extern bool ExtremExists( const char* theName );
extern bool ExtremLoad( const char* theName );
extern struct RExtrem* ExtremNew( int theTyp, double theDate, int theMag, const char* theObsCode, const char* theComment );
extern void ExtremDelete();
extern void ExtremGraphShow();
extern void ExtremGraph();
extern void ExtremGraphPaint( int theMode, const char* theFileName );
extern void ExtremGraph_Reset();
extern void ExtremGraph_DateRange( double jd0, double jd1 );

// Import Longperiod or Shortperiod data list from BAV format
extern void ExtremConvertBAV( const char* theNameBAV, bool isTypeLong );

// Import Elements from BAV Circular
extern void ExtremReadBAVElements( const char* theFileName );

#endif /* __VS_EXTREM_H */
