#ifndef __VS_FILE_H
#define __VS_FILE_H

#include "vs_sub.h"

void ReadObservers();
void WriteObservers();
void DeleteObservers();
void CheckObserver( const char* obsCode );
const RObserver* FindObserver( const char* obsCode );
const int GetObserverIndex( const char* obsCode );
bool CanObserverOutput( const char* obsCode, const struct RHell* hellPtr );
int ReadObsCodeConversionList( const char* filename );

void ReadOrganisation();
void DeleteOrganisation();
bool IsObservationInOrg( const struct RHell* aHell, 
                            const struct ROrganisation *anOrg,
                            struct RObserver **findObserverPtr,
                            int *findObserverN );

char* Make_GCVS_Name_From_Filename( const char* starFileName, char* gcvsName );
char* Read_GCVS_Star( const char* name, char* line );
                          
void Daten_GCVS_Suche (const char *nameBild, const char* nameStern);
void Daten_GCVS();
void CreateDataOfGCVS (const char* options);

struct RDisk* Stern_Laden( const char* theName );
void Daten_Laden();
FILE *Open_STV (char *stv_name, struct RStern *stern);
void Read_STV_Hell (FILE *fDat, struct RHell *hell);
void Daten_Laden_Stern();
void Daten_Laden_Sonne();
void Daten_Speichern();
void Daten_Speichern_Neu();
void ca_Daten_Speichern();
void Daten_Stern_Neu (const char* sternbild, const char* sternname);

void Beob_VSNET();
void Beob_AFOEV();
void Beob_AAVSO();

void ExportAveragedData();

void _ChangeFileFormat();

#endif
