
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <dirent.h>

#include "vs_forms.h"

#include "libtl/libtl_string.h"
#include "libtl/libtl_picture.h"
#include "libtl/libtl_draw.h"
#include "libtl/libtl_printer.h"

#include "vs_ver.h"
#include "vs_sub.h"
#include "vs_language.h"
#include "vs_main.h"
#include "vs_file.h"
#include "vs_extrem.h"
#include "vs_chart.h"

#ifndef NO_FORMS
#include "bitmaps/varstars.normal.xpm"
#include "bitmaps/varstars.small.xpm"
#endif

/****************************************************************************/
/*  showform_vs                                                             */
/****************************************************************************/
void ShowMainForm()
{
#ifndef NO_FORMS
	unsigned int w,h; 
	int          hotx,hoty;
	char 			 str[80];
  
	fd_vs = create_form_vs();

	/* Mens aufbauen */
	
	fl_set_object_label( fd_vs->pd_file, LS(10) );
	fl_set_menu(fd_vs->pd_file  ,LS(11) );
	fl_addto_menu(fd_vs->pd_file,"------------");
	fl_set_menu_item_mode(fd_vs->pd_file,2,FL_PUP_GREY);
	fl_addto_menu(fd_vs->pd_file,LS(12) );
	fl_addto_menu(fd_vs->pd_file,LS(13) );
	fl_addto_menu(fd_vs->pd_file,LS(14) );
	fl_addto_menu(fd_vs->pd_file,"------------");
	fl_set_menu_item_mode(fd_vs->pd_file,6,FL_PUP_GREY);
	fl_addto_menu(fd_vs->pd_file,LS(15) );
	fl_addto_menu(fd_vs->pd_file,"------------");
	fl_set_menu_item_mode(fd_vs->pd_file,8,FL_PUP_GREY);
	fl_addto_menu(fd_vs->pd_file,LS(16 ));

	fl_set_object_label( fd_vs->pd_beobachtungen, LS(20) );
	fl_set_menu(fd_vs->pd_beobachtungen,  LS(21) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(22) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(23) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(24) );
	fl_addto_menu(fd_vs->pd_beobachtungen,"-----------------------");
	fl_set_menu_item_mode(fd_vs->pd_beobachtungen,5,FL_PUP_GREY);
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(25) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(26) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(27) );
	fl_addto_menu(fd_vs->pd_beobachtungen,LS(28) );

	fl_set_object_label( fd_vs->pd_auswertung, LS(30) );
	fl_set_menu  (fd_vs->pd_auswertung, LS(31) );
	fl_addto_menu(fd_vs->pd_auswertung, LS(32) );
	fl_addto_menu(fd_vs->pd_auswertung, LS(33) );
	fl_addto_menu(fd_vs->pd_auswertung, LS(34) );
	fl_addto_menu(fd_vs->pd_auswertung, LS(35) );
	fl_addto_menu(fd_vs->pd_auswertung,"-----------------");
	fl_set_menu_item_mode(fd_vs->pd_auswertung,6,FL_PUP_GREY);
	fl_addto_menu(fd_vs->pd_auswertung, LS(36) );

	fl_set_object_label( fd_vs->pd_meldungen, LS(40) );
	fl_set_menu  (fd_vs->pd_meldungen,LS(41) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(42) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(43) );
	fl_addto_menu(fd_vs->pd_meldungen,"-----------------");
	fl_addto_menu(fd_vs->pd_meldungen,LS(44) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(45) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(46) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(47) );
	fl_addto_menu(fd_vs->pd_meldungen,LS(48) );

	//fl_set_object_shortcut(fd_vs->shortcut, "^L^S^Q^B^V^P^H^E^T^K^I^O&1&12", FALSE);
	fl_set_object_shortcut(fd_vs->shortcut, "#L#S#Q#B#V#P#H#E#T#K#I#O&1&12", FALSE);

	fl_set_pixmap_data(fd_vs->logo,varstars_small_xpm); 

	fl_set_object_label( fd_vs->LName, LS(80) );
	fl_set_object_label( fd_vs->LLight, LS(81) );
	fl_set_object_label( fd_vs->LPeriod, LS(82) );
	fl_set_object_label( fd_vs->Lto, LS(92) );
	fl_set_object_label( fd_vs->LPeriodScale, LS(83) );
	fl_set_object_label( fd_vs->LImportScale, LS(83) );
	sprintf(str,"%s/3mag",LS(83));
	fl_set_object_label( fd_vs->LPhaseScale, str );
	fl_set_object_label( fd_vs->LPhase, LS(84) );
	fl_set_object_label( fd_vs->LDate, LS(85) );
	fl_set_object_label( fd_vs->LSpectrum, LS(86) );
	fl_set_object_label( fd_vs->LDistance, LS(87) );
	fl_set_object_label( fd_vs->LDistanceScale, LS(88) );
	fl_set_object_label( fd_vs->LType, LS(89) );
	fl_set_object_label( fd_vs->LDesignation, LS(90) );
	fl_set_object_label( fd_vs->LChart, LS(91) );
	fl_set_object_label( fd_vs->Alert, LS(93) );

	/* Icon-Pixmap */
	icon_vs = fl_create_from_pixmapdata(fl_default_win(),
                                       varstars_normal_xpm,
                                       &w,&h,&icon_vs_mask,&hotx,&hoty,0);
	fl_set_form_icon(fd_vs->vs,icon_vs,icon_vs_mask); 
  
	fl_show_form( fd_vs->vs, FL_PLACE_CENTER, FL_FULLBORDER, "VarStars" );
#endif
}


void LowerMainForm()
{
	fl_lower_form( fd_vs->vs );
}

void RaiseMainForm()
{
	fl_raise_form( fd_vs->vs );
}


/****************************************************************************/
/*  ShowInfo                                                                */
/****************************************************************************/
void cb_ShowInfo(FL_OBJECT *ob, long data)
{
#ifndef NO_FORMS
	fl_hide_form(fd_info->info);
#endif
}

void ShowInfo( bool createHTML )
{
	char text[256];

#	ifndef NO_FORMS
	if (fd_info==NULL) 
	{
		fd_info = create_form_info();
		fl_set_pixmap_data(fd_info->logo,varstars_normal_xpm); 
	}
#	endif

	if (createHTML)
	{
		sprintf(text,"(c) %s<BR>\n    %s<BR>\n<BR>\n%s<BR>\n<BR>\n%s@%s<BR>"
		            ,VerAutor,VerDatum,LS(1),VerEMail1,VerEMail2);
	}
	else
	{
		sprintf(text,"(c) %s\n    %s\n\n%s\n\n%s@%s"
		            ,VerAutor,VerDatum,LS(1),VerEMail1,VerEMail2);
	}

#	ifndef NO_FORMS
	fl_set_object_label(fd_info->text,text);
	fl_show_form(fd_info->info,FL_PLACE_MOUSE,FL_FULLBORDER,"VarStars");
	fl_raise_form(fd_info->info);
#	else
	printf("%s\n",text);
#	endif
}

/****************************************************************************/
/*  Daten_DirLaden                                                          */
/****************************************************************************/
long GetNameNr (char *s)
{
	char t[10];
	long nr;
	strn0cpy(t,s+3,5);
	sscanf(t+1,"%li",&nr);
	if ((strlen(t)==1) && (t[0]>='r') && (t[0]<='z')) 
		return (long)t[0]-(long)'r';
	else if ((strlen(t)==2) && (t[0]>='r') && (t[0]<='z')) 
		return 10+(long)(t[0]-'r')*10+(long)(t[1]-t[0]);
	else if ((strlen(t)==2) && (t[0]>='a') && (t[0]<='q')) 
		return 100+(long)(t[0]-'a')*30+(long)(t[1]-t[0]);
	else if ((t[0]=='v') && (nr>0)) 
		return 1000+nr;
	else 
		return 200000+(long)t[0]*128+(long)t[1];
}

bool TestNames (char *s1, char *s2)
{
	if (strncmp(s1,s2,3)>0) 
		return TRUE;
	else if (strncmp(s1,s2,3)==0) 
	{
		if (GetNameNr(s1)>GetNameNr(s2)) 
		{
			if (GetNameNr(s2)<1000) 
				return TRUE;
			else if (strcmp(s1,s2)>0) 
				return TRUE;
		}
	}
	return FALSE;
}

void TestPfad (char *pfadRC, char *pfadTest, char *variable, bool slash)
{
	char *c;
	FILE *f;
	if (pfadTest[0]!='\0') 
	{
		c = strchr(pfadTest,' ');
		if (c!=NULL) 
			*c = '\0';
		f = fopen(pfadTest,"r");
		if (f==NULL) 
		{
			fprintf(stderr,"%s%s: Path for %s doesn't exist!\n",VerError,pfadRC,variable);
			pfadTest[0] = '\0';
		} 
		else 
		{
			if (slash && (pfadTest[strlen(pfadTest)-1] != '/'))
				strcat(pfadTest,"/");
			fclose(f);  
		} 
	}
}

void CopyPath (char* dest, char* src, int maxlen )
{
	if (src[0]=='~') 
	{
		int homelen = strlen(pfadHome);
		strn0cpy( dest, pfadHome, maxlen );
		strcat(dest,"/");
		strn0cpy( dest+homelen, src+1, maxlen-homelen );
	} 
	else 
	{
		strn0cpy( dest, src, maxlen );
	}
}

void Daten_DirLaden()
{
  char   name[32], pfad[256], *c;
  struct dirent **dirptr;
  struct RDisk *diskNew,*diskSort,*diskLast;
  struct RDisk *diskABC[27];
  int    i,n,d;
  
  if (diskFirst!=NULL) 
    return;
  
  for (i=0; i<27; i++) 
    diskABC[i] = NULL;
  
  strcpy(pfad,pfadSTV);
  n = scandir(pfad,&dirptr,0,alphasort);
  diskFirst       = malloc(sizeof(struct RDisk));
  sprintf(diskFirst->name,"sonne");
  diskFirst->next = NULL;
  for (d=0; d<n; d++) {
    strcpy(name, dirptr[d]->d_name);
    c = strrchr(name,'.');
    if ((c!=NULL) && (strcmp(c,".stv")==0)) {
      *c = (char)0;
      if (strcmp(name,"sonne")!=0) {
        diskNew = malloc(sizeof(struct RDisk));
        strcpy( diskNew->name, name );
        strn0cpy( diskNew->stb, name, 3 );
        toupperstr(diskNew->stb);
        strn0cpy( diskNew->index, name+3, sizeof(diskNew->index)-1 );
        toupperstr(diskNew->index);
        i = name[0]-'a';
        if ((i<0) || (i>25)) i=26;
        diskSort = diskABC[i];
        if (diskSort==NULL) {
          diskABC[i]    = diskNew;
          diskNew->next = NULL;
        } else {
          diskLast = NULL;
          while (diskSort!=NULL) {
            if (TestNames(diskSort->name, name)) 
              diskSort = NULL;
            else {
              diskLast = diskSort;
              diskSort = diskSort->next;
            }
          }
          if (diskLast==NULL) {
            diskNew->next = diskABC[i];
            diskABC[i]    = diskNew;
          } else {
            diskNew->next = diskLast->next;
            diskLast->next= diskNew;
          }
        }
      }
    }
  }
  diskLast = diskFirst;
  for (i=0; i<27; i++) {
    diskSort = diskABC[i];
    if (diskSort!=NULL) {
      diskLast->next = diskSort;
      while (diskSort->next!=NULL) diskSort = diskSort->next;
      diskLast = diskSort;
    }
  }
}

void CreateDataFiles( const char* pathList )
{
	char line[128], realName[20], starPath[256];
	FILE *fStar;
	FILE *fList = fopen(pathList,"r");
	if (!fList) 
	{
		if (strlen(pathList)==0 || pathList[0]==',')
			CreateDataOfGCVS(pathList);
		else 
			fprintf(stderr,"Filelist %s not found!\n", pathList );
		return;
	}
	
	while (fgets(line,sizeof(line),fList)) 
	if (line[0]!='#' && strlen(line)>12) 
	{
		char *ptr;
		char *starname = line+9;
		char *designation = line;
		toupperstr(line);
		line[8] = 0;
		if (line[7]==' ')	line[8] = 0;
		ptr = starname;
		while (*ptr) ptr++;
		ptr--;
		if (*ptr=='\n') 
		{	*ptr = 0; ptr--; }
		while (*ptr==' ') 
		{	*ptr = 0; ptr--; }
		ptr = strchr(starname,' ');
		if (ptr) {
			if (strchr(ptr+1,' ') || strcmp(starname,"SN")==0)
			{	fprintf(stderr,"*** %s not created\n", starname );
				continue;
			}
			*ptr = 0;	ptr++;
			sprintf( realName, "%s%s", ptr, starname );
		} else 
			strcpy( realName, starname );
		tolowerstr(realName);
		sprintf(starPath, "%s%s.stv", pfadSTV, realName );
		fStar = fopen(starPath,"r");
		if (fStar) {
			fclose(fStar);
			continue;
		}

		fprintf( stderr, "%s\n", realName );
		DatenLoeschen();
		diskLoad = malloc(sizeof(struct RDisk));
		strcpy(diskLoad->name,realName);
		tolowerstr(diskLoad->name);
		strn0cpy(diskLoad->stb, ptr ,3);
		toupperstr(diskLoad->stb);
		strn0cpy(diskLoad->index, starname,9);
		toupperstr(diskLoad->index);
		sprintf(stern.name,"%s %s",starname,ptr);
		toupperstr(stern.name);

		Daten_GCVS_Suche( ptr, starname );
		strcpy( stern.designation, designation );
		Daten_Speichern();
	}
	fclose(fList);
	exit(0);
}

/****************************************************************************/
/*  Laden_RC                                                                */
/****************************************************************************/
#	define scanWP(wp) sscanf(z+m,"%i %i %i %i",&wp.x,&wp.y,&wp.w,&wp.h)

bool Laden_RC (char *home, char *pfadRC)
{
	int            m;
	char          *c, s[30], z[128], druckBefehl[80];
	FILE          *fRC;
	FILE          *fError = stderr;
	struct RAlias *alias;

	fRC = fopen(pfadRC,"r");
#	ifdef __debug
	fprintf(fError,"%sopen rc: %s\n",VerError,pfadRC);
#	endif   
	if (fRC==NULL) 
	{
		fprintf(fError,"%s%s not found!\n",VerError,pfadRC);
		return FALSE;
	}

	while (NULL!=fgets(z,sizeof(z),fRC)) 
	{
		z[sizeof(z)-1] = '\0';
		c = strchr(z,';');
		if (c!=NULL) *c = '\0'; 
		m = strlen(z)-1;
		while ((m>0) && (z[m]<=' ')) z[m--] = '\0';
		while ((z[0]==' ') && (z[0]!=0)) 
			memmove(z,z+1,127);
		m=0;
		while ((z[m]!=' ') && (z[m]!='\0')) 
		{
			s[m] = toupper(z[m]);
			m++;
		}
		s[m] = '\0';
		while ((z[m]==' ') && (z[m]!='\0')) m++;
#		ifdef __debug
		fprintf(fError,"%s: '%s' '%s'\n",pfadRC,s,z+m);
#		endif
		if (strcmp(s,"AAVSO")==0) 
		{
			strn0cpy(initialAAVSO,z+m,5);
			m = strlen(initialAAVSO);
			while ((initialAAVSO[m]==' ') && (m>1)) m--;
			initialAAVSO[m] = (char)0;
		} 
		else 
		if (strcmp(s,"AFOEV")==0) 
			strn0cpy(initialAFOEV,z+m,5);
		else 
		if (strcmp(s,"ALIAS")==0) 
		{
			memmove(z,z+m,sizeof(z)-1-m);
			c = strchr(z,'=');
			if (c!=NULL) 
			{
				alias = malloc(sizeof(RAlias));
				alias->next   = aliasFirst;
				aliasFirst    = alias;
				m=0;
				while ((z[m]!='=') && (z[m]!=' '))
				{
					alias->org[m] = toupper(z[m]);
					m++;
				}
				alias->org[m] = '\0';
				m=0;
				c++;
				while (*c==' ') c++;
				while ((*c!='\0') && (*c!=' ')) 
				{
					alias->muster[m] = toupper(*c);
					c++; m++;
				}
				alias->muster[m] = '\0';
#				ifdef __debug
				fprintf(fError,"ALIAS '%s'='%s'\n",alias->org,alias->muster);
#				endif        
			}
		}
		else if (strcmp(s,"AUTOSCAN_VSNET")==0) 
			autoScanVSNET = TRUE;
		else if (strcmp(s,"BAV")==0) 
			strn0cpy(initialBAV, z+m,5);
		else if (strcmp(s,"CITY")==0)  
			strn0cpy(bavCity, z+m,30);
		else if (strcmp(s,"COUNTRY")==0)
			strn0cpy(bavCountry, z+m,30);
		else if (strcmp(s,"DR_SPALTEN")==0)
			monatEinschubX = atoi(z+m);  
		else if (strcmp(s,"DR_ZEILEN")==0)
			monatEinschubY = atoi(z+m);  
		else if (strcmp(s,"GRAFIK_FONT")==0)
			strn0cpy(pfadFont, z+m,127);
		else if (strcmp(s,"GRAFIK_FORMAT")==0) 
		{
			if (isdigit(z[m]))
				grafikDruckFormat = atoi(z+m);
			else 
			{
		 		toupperstr(z+m);
		 		if (strcmp(z+m,"GIF")==0)
					grafikDruckFormat = DRAW_GIF;
				else if (strcmp(z+m,"BMP")==0)
					grafikDruckFormat = DRAW_BMP;
				else if (strcmp(z+m,"PPM")==0)
					grafikDruckFormat = DRAW_PPM;
				else if (strcmp(z+m,"PS")==0)
					grafikDruckFormat = DRAW_PS;
			}
		}
		else if (strcmp(s,"GRAFIK_X")==0)
			grafikDruckX = atoi(z+m);  
		else if (strcmp(s,"GRAFIK_Y")==0)
			grafikDruckY = atoi(z+m);  
		else if (strcmp(s,"INSTR")==0)
			strn0cpy(bavInstrument, z+m, sizeof(bavInstrument)-1);
		else if (strcmp(s,"IMPORT_DELTA_T")==0)
			importDeltaT = atof(z+m);  
		else if (strcmp(s,"LINK_IMG")==0)
			strn0cpy(linkIMG, z+m,128);
		else if (strcmp(s,"MAIL_AAVSO")==0)
			strn0cpy(mailAAVSO, z+m,79);
		else if (strcmp(s,"MAIL_AFOEV")==0)
			strn0cpy(mailAFOEV, z+m,79);
		else if (strcmp(s,"MAIL_BAV")==0)
			strn0cpy(mailBAV, z+m,79);
		else if (strcmp(s,"MAIL_VSNET")==0)
			strn0cpy(mailVSNET, z+m,79);
		else if (strcmp(s,"LANGUAGE")==0)
			SetLanguage(z+m);
		else if (strcmp(s,"OBS")==0)
			strn0cpy(bavObserver, z+m,30);
		else if (strcmp(s,"P_BAV")==0)
			CopyPath(pfadBAV, z+m,127);
		else if (strcmp(s,"P_CHART")==0)
			CopyPath(pfadChart, z+m,127);
		else if (strcmp(s,"P_GCVS")==0)
			CopyPath(pfadGCVS, z+m,127);
		else if (strcmp(s,"P_OBSERVER")==0)
			CopyPath(pfadObserver, z+m,127);
		else if (strcmp(s,"P_ORGANISATION")==0)
			CopyPath(pfadOrganisation, z+m,127);
		else if (strcmp(s,"P_OUT")==0)
			CopyPath(pfadAblage, z+m,127);
		else if (strcmp(s,"P_STV")==0)
			CopyPath(pfadSTV, z+m,127);
		else if (strcmp(s,"P_TMP")==0)
			CopyPath(pfadTMP, z+m,127);
		else if (strcmp(s,"P_VSNET")==0)
			CopyPath(pfadVSNET, z+m,127);
		else if (strcmp(s,"PRINT")==0)
			strn0cpy(druckBefehl, z+m,79);
		else if (strcmp(s,"PRINT_INS_X")==0)
			grafikDruckEinschubX = atoi(z+m);
		else if (strcmp(s,"PRINT_INS_Y")==0)
			grafikDruckEinschubY = atoi(z+m);
		else if (strcmp(s,"STREET")==0)
			strn0cpy(bavStreet, z+m,30);
		else if (strcmp(s,"TL_IDENT")==0)
			tageslisteMitIdent = TRUE;
		else if (strcmp(s,"TL_NEGATIV")==0)
			tageslisteMitNegativ = TRUE;
		else if (strcmp(s,"WINPOS")==0)
			saveWinpos = TRUE;
		else if (strcmp(s,"WP_BAV_LK")==0)
			scanWP(fd_bav_kurve_wp);
		else if (strcmp(s,"WP_BEOB")==0)
			scanWP(fd_beob_list_wp);
		else if (strcmp(s,"WP_CHART")==0)
			scanWP(fd_chart_wp);
		else if (strcmp(s,"WP_HELLGRAF")==0)
			scanWP(fd_graf_hell_wp);
		else if (strcmp(s,"WP_PHASE")==0)
			scanWP(fd_graf_phase_wp);
		else if (strcmp(s,"ZIP")==0)
			strn0cpy(bavZip, z+m,10);
	}
	fclose(fRC);
  
	if (!picture_font_load(pfadFont)) 
		fprintf(fError,"%s%s: Error while loading font %s\n",VerError,pfadRC,pfadFont);
	TestPfad(pfadRC,pfadGCVS,"P_GCVS",FALSE);
	TestPfad(pfadRC,pfadAblage,"P_OUT",TRUE);
	TestPfad(pfadRC,pfadBAV,"P_BAV",TRUE);
	TestPfad(pfadRC,pfadVSNET,"P_VSNET",FALSE);
	TestPfad(pfadRC,pfadTMP,"P_TMP",TRUE);
	if (pfadTMP[0]!=(char)0)
	{
		sprintf(z,"%svs*.tmp",pfadTMP);
		remove(z);
  	}
  	TestPfad(pfadRC,pfadSTV,"P_STV",TRUE);
  	if (pfadSTV[0]=='\0') 
  		return FALSE;
  	if (pfadSTV[strlen(pfadSTV)-1] != '/')
   	strcat(pfadSTV,"/");
    
	{	char strCopyright[80];
		sprintf(strCopyright,"VARSTARS %s, %s, %s@%s\n",VerDatum,VerAutor,VerEMail1,VerEMail2);
		draw_setup_copyright(strCopyright);
	}
	SetupPrinter(druckBefehl,pfadTMP);
	
	return TRUE;
}

/****************************************************************************/
/*  ScanArgs                                                                */
/****************************************************************************/
void ScanArgs (int argc, char *argv[])
{
	int m;
	for (m=1; m<argc; m++) 
	{
		if (argv[m][0]=='-') 
		{
			switch (argv[m][1]) {
			case 'D': 
				if (argv[m][2]=='*') {
					useDateMode = USEDATE_ECHTZEIT;
				} else if (atoi(&argv[m][2])<1000) {
					double jd;
					GetDateStr(useDateStr);
					jd = Zeit2JulDat(useDateStr) - atoi(&argv[m][2]);
					JulDat2Zeit(jd,useDateStr);
					useDateStr[10] = '\0';
					useDateMode = USEDATE_DATUM;
				} else {
					sprintf(useDateStr,"%.2s.%.2s.20%.2s",&argv[m][2],&argv[m][4],&argv[m][6]);
					useDateMode = USEDATE_DATUM;
				}  
				break;
			case 'f': 
				switch (argv[m][2]) {
				case 'b': formDatum = _TimeDisplay_Normal; break;
				case 'd': formDatum = _TimeDisplay_Astro;	 break;
				case 'j': formDatum = _TimeDisplay_JD;     break;
				}
				break;
			case 'n': 
				mitNegativBeob = (argv[m][2]!='-');
				break;
			case 'z': 
				switch (argv[m][2]) {
				case 'u': JulDatZone=_UT; break;
				case 'm': JulDatZone=_MEZ; break;
				case 's': JulDatZone=_MESZ; break;
				}
				break;
			case 'o':
				strncpy(standardObserver,argv[m]+2,20);
				standardObserver[19] = 0;
				break;
			case 'K':
				switch (argv[m][2]) {
				case '.':
					keyboardNumerikPoint = TRUE;  
					break;
				case ',':
					keyboardNumerikPoint = FALSE;  
					break;
				}
				break;
			case 'S':
				strn0cpy(scriptArg,&argv[m][3],sizeof(scriptArg)-1);
				switch (argv[m][2]) {
				case 'B':
					scriptMode = SCRIPT_BEOB_NEU;
					break;
				case 'C':
					scriptMode = SCRIPT_CHART;
					break;
				case 'G':
					scriptMode = SCRIPT_GRAFIK;	
					break;
				case 'H':
					scriptMode = SCRIPT_HTML_STERN;
					break;
				case 'M':
					scriptMode = SCRIPT_MONAT;
					break;
				case 'T':
					scriptMode = SCRIPT_TAG;	
					break;
				case 'V':
					scriptMode = SCRIPT_VSNET;
					break;
				case 'X':
					scriptMode = SCRIPT_MAX_LISTE;
					break;
				}
				break;  
			case 'C':
				switch (argv[m][2]) {
				case 'G':
					CreateDataFiles( &argv[m][3] );
					break;
				case 'B':
					scriptMode = SCRIPT_BAV_DB;
					break;
				case 'L':
					if (argv[m][3]=='=')
						ExtremConvertBAV(&argv[m][4],true);
					break;
				case 'S':
					if (argv[m][3]=='=')
						ExtremConvertBAV(&argv[m][4],false);
					break;
				case 'E':
					if (argv[m][3]=='=')
						ExtremReadBAVElements(&argv[m][4]);
					break;
				}
				break;
			case 'T':
#ifndef NO_FORMS
				Simbad2Chart( &argv[m][2] );
#endif
				break;
			case '?':
			case '-':	// e.g. --help
			case 'h':
				fprintf(stderr,"VARSTARS %s\n(c) %s\nEMail: %s@%s\n",VerDatum,VerAutor,VerEMail1,VerEMail2);
				fprintf(stderr,"Parameter: -n[-|+]           Darstellung ohne/mit negativen Beobachtungen\n");
				fprintf(stderr,"           -f[b|d|j]         Datumsformat buergerlich/dezimal/julianisch\n");
				fprintf(stderr,"           -z[u|m|s]         Zeitzone UT/MEZ(Nov-Mrz)/MESZ(Apr-Okt)\n");
				fprintf(stderr,"           -K.               Interne Umwandlung des ',' in '.'\n");
				fprintf(stderr,"           -SB               Neueingabe von Beobachtungen\n");
				fprintf(stderr,"           -SC[name]         Chart-Viewer mit Sternname oeffnen\n");
				fprintf(stderr,"           -SH[per=<perioden>]\n");
				fprintf(stderr,"                             HTML-Infoseite erzeugen mit Helligkeitskurve\n");
				fprintf(stderr,"           -SMjjjjmm[A(+)B(+)F] Monatsliste erstellen (AAVSO, BAV, AFOEV)\n");
				fprintf(stderr,"           -ST<tage>         VSNET-Report fr die letzten Tage\n");
				fprintf(stderr,"           -SX<mag><-tage><+tage><*wochen>  Maximaliste erzeugen\n");
				fprintf(stderr,"           -o[observercode]\n");
				fprintf(stderr,"           -Dttmmjj / -Dt  -D0 heute -D1 gestern, ...\n");
				fprintf(stderr,"           -C<typ>=<file>    File-Conversion/Import\n");
				fprintf(stderr,"                             -CL  BAV Langperiodische Ergebnisse\n");
				fprintf(stderr,"                             -CS  BAV Kurzperiodische Ergebnisse\n");
				fprintf(stderr,"                             -CE  Importiere Elemente aus BAV Circular\n");
				fprintf(stderr,"                             -CG  Erzeuge STV-Files mittels GCVS\n");
				fprintf(stderr,"                             -CB  Erzeuge STV-Files\n");
				fprintf(stderr,"           [sternname]       Beim Start die Daten dieses Sterns laden\n");
				exit(0);
			default:
				fprintf(stderr,"%sUnknown parameter '%s'\n",VerError,argv[m]);
			}
		} 
		else 
		{	/* Stern laden */
			struct RDisk *diskTest = Stern_Laden(argv[m]);
			if (diskTest==NULL)
			{
				fprintf(stderr,"%sError while loading '%s'\n",VerError,argv[m]);
			}
		}
	} // eof for
}

/****************************************************************************/
/*  Start                                                                   */
/****************************************************************************/

void StartInitVars ()
{
	char s[64];
	
	initialAAVSO[0] = '\0';
	initialAFOEV[0] = '\0';
	aliasFirst      = NULL;
	observerFirst	 = NULL;
	initialBAV[0]   = '\0';
	bavCity[0]      = '\0';
	bavCountry[0]   = '\0';
	bavInstrument[0]= '\0';
	bavObserver[0]  = '\0';
	bavStreet[0]    = '\0';
	bavZip[0]       = '\0';
	standardObserver[0] = '\0';
	sprintf(pfadFont,"/usr/lib/kbd/consolefonts/default8x9");
	pfadGCVS[0]     = '\0';
	sprintf(pfadAblage,"%s/varstar",pfadHome);
	sprintf(pfadSTV   ,"%s/varstar",pfadHome);
	sprintf(pfadChart ,"%s/varstar/charts",pfadHome);
	sprintf(pfadObserver,    "%s/varstar/observer.lst",pfadHome);
	sprintf(pfadOrganisation,"%s/varstar/organisation.lst",pfadHome);
	pfadVSNET[0]    = '\0';
	pfadBAV[0]      = '\0';
	strcpy(linkIMG,"http://www.lavision.de/~tlange/vs/out/");
	monatEinschubX  = 2;
	monatEinschubY  = 2;
	monatEinschubNeu= false;
	importDeltaT    = 0.6;
	canAverageBAVobs= false;
	grafikDruckFormat = 0; 
	grafikDruckX = 640;
	grafikDruckY = 400;
	grafikDruckEinschubX = 0;
	grafikDruckEinschubY = 0;
	mailAAVSO[0] = '\0';
	mailAFOEV[0] = '\0';
	mailBAV[0]   = '\0';
	mailVSNET[0] = '\0';
	tageslisteMitIdent   = false;
	tageslisteMitNegativ = false;
	saveWinpos         = false;
	fd_bav_kurve_wp.x  = 0;
	fd_beob_list_wp.x  = 0;
	fd_chart_wp.x      = 0;
	fd_graf_hell_wp.x  = 0;
	fd_graf_phase_wp.x = 0;

	diskLoad 	  = NULL;
	hellFirst 	= NULL;
	sonneFirst	= NULL;
	DatenLoeschen();
	mitNegativBeob  = TRUE;
	mitTheoretKurve = TRUE;
	formDatum 	= 0;
	besDatumVon	= Zeit2JulDat("01.01.1700");
	besDatumBis	= Zeit2JulDat("01.01.2100");
	besArt	    = 255;
 	keyboardNumerikPoint = TRUE;  
 	autoScanVSNET = FALSE;
	GetDateStr(s);
	if (strchr("4567890",s[4])!=NULL)
   	JulDatZone  = _MESZ;
  	else 
   	JulDatZone  = _MEZ;
	stern.name[0] = '\0';
	stern.typ[0]  = '\0';
	stern.designation[0] = '\0';
	stern.karte[0]= '\0';
	flagNeueDaten = FALSE;
	useDateStr[0] = '\0';
	useDateMode   = USEDATE_GESTERN;
	scriptMode    = SCRIPT_NO;
}
				
bool Start (int argc, char *argv[], char *pfadRC)
{
	char *home;
	
  	home = getenv("HOME");
  	if (home==NULL) 
	{
		strcpy(pfadHome,".");
  	}
	else 
	{
  		strcpy(pfadHome,home);
  	}
  	sprintf(pfadRC,"%s/.varstarrc",pfadHome);
  
  	StartInitVars();
	if (!Laden_RC(pfadHome,pfadRC))
		return FALSE;
	
	diskFirst = NULL;
	Daten_DirLaden();

	ScanArgs(argc,argv);
	ReadObservers();
	ReadOrganisation();
	if (standardObserver[0])
		CheckObserver(standardObserver);
   
	return TRUE;
}

/****************************************************************************/
/*  Speichern_RC                                                            */
/****************************************************************************/
void Speichern_RC (char *pfadRC)
{
# define writeWP(name,wp) \
		if (wp.x>0) fprintf(fRC,"%s %i %i %i %i\n",name,wp.x,wp.y,wp.w,wp.h);

	FILE* fRC;
	char  z[256],s[32],*buf;
	long  len,pos;
	int   i;
 
	fRC = fopen(pfadRC,"r");
	fseek(fRC,0,SEEK_END);
	len = ftell(fRC);
	buf = (char*) malloc(len);
	if (buf==NULL) 
	{
 		fclose(fRC);
 		return;
 	}
 	fseek(fRC,0,SEEK_SET);
 	fread(buf,1,len,fRC);
 	fclose(fRC);
 	sprintf(z,"%s~",pfadRC);
 	fRC = fopen(z,"w");
 	fwrite(buf,1,len,fRC);
 	fclose(fRC);

	pos = 0;
	fRC = fopen(pfadRC,"w");
	while (pos<len)
	{
		i = 0;
		while ((buf[pos+i]!='\0') && (buf[pos+i]!='\n')) 
		{
  			z[i] = buf[pos+i];
			i++;
		}
		z[i++] = '\0';
	  	pos += i;
  		sscanf(z,"%s",s);
	  	if (monatEinschubNeu) 
		{
			if (strcmp(s,"DR_SPALTEN")==0)
				z[0] = '\0';
			else if (strcmp(s,"DR_ZEILEN")==0) 
				z[0] = '\0';
		}	
		else 
		if (saveWinpos) 
		{
			if (strcmp(s,"WP_BAV_LK")==0)
				z[0] = '\0';
			else if (strcmp(s,"WP_BEOB")==0) 
				z[0] = '\0';
			else if (strcmp(s,"WP_CHART")==0) 
				z[0] = '\0';
			else if (strcmp(s,"WP_HELLGRAF")==0) 
				z[0] = '\0';
			else if (strcmp(s,"WP_PHASE")==0) 
				z[0] = '\0';
		}
		if (z[0]!='\0')
			fprintf(fRC,"%s\n",z);
	}

	if (monatEinschubNeu) 
	{
		fprintf(fRC,"DR_SPALTEN %i\n",monatEinschubX);
		fprintf(fRC,"DR_ZEILEN %i\n",monatEinschubY);
	}
	if (saveWinpos) 
	{
		writeWP("WP_BAV_LK"  ,fd_bav_kurve_wp);
		writeWP("WP_BEOB"    ,fd_beob_list_wp);
		writeWP("WP_CHART"   ,fd_chart_wp);
		writeWP("WP_HELLGRAF",fd_graf_hell_wp);
		writeWP("WP_PHASE"   ,fd_graf_phase_wp);
	}

	fclose(fRC);
#	undef writeWP
}

